<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeoFenceSelection_V3 StructType
 * @subpackage Structs
 */
class GeoFenceSelection_V3 extends AbstractStructBase
{
    /**
     * The IncludeInactive
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeInactive;
    /**
     * The IncludeLinkedVehicles
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeLinkedVehicles;
    /**
     * The IdentifierGeoFence
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\IdentifierGeoFence
     */
    public $IdentifierGeoFence;
    /**
     * The IdentifierVehicleStrategy
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\IdentifierVehicleStrategy
     */
    public $IdentifierVehicleStrategy;
    /**
     * Constructor method for GeoFenceSelection_V3
     * @uses GeoFenceSelection_V3::setIncludeInactive()
     * @uses GeoFenceSelection_V3::setIncludeLinkedVehicles()
     * @uses GeoFenceSelection_V3::setIdentifierGeoFence()
     * @uses GeoFenceSelection_V3::setIdentifierVehicleStrategy()
     * @param bool $includeInactive
     * @param bool $includeLinkedVehicles
     * @param \StructType\IdentifierGeoFence $identifierGeoFence
     * @param \StructType\IdentifierVehicleStrategy $identifierVehicleStrategy
     */
    public function __construct($includeInactive = null, $includeLinkedVehicles = null, \StructType\IdentifierGeoFence $identifierGeoFence = null, \StructType\IdentifierVehicleStrategy $identifierVehicleStrategy = null)
    {
        $this
            ->setIncludeInactive($includeInactive)
            ->setIncludeLinkedVehicles($includeLinkedVehicles)
            ->setIdentifierGeoFence($identifierGeoFence)
            ->setIdentifierVehicleStrategy($identifierVehicleStrategy);
    }
    /**
     * Get IncludeInactive value
     * @return bool
     */
    public function getIncludeInactive()
    {
        return $this->IncludeInactive;
    }
    /**
     * Set IncludeInactive value
     * @param bool $includeInactive
     * @return \StructType\GeoFenceSelection_V3
     */
    public function setIncludeInactive($includeInactive = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeInactive) && !is_bool($includeInactive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeInactive, true), gettype($includeInactive)), __LINE__);
        }
        $this->IncludeInactive = $includeInactive;
        return $this;
    }
    /**
     * Get IncludeLinkedVehicles value
     * @return bool
     */
    public function getIncludeLinkedVehicles()
    {
        return $this->IncludeLinkedVehicles;
    }
    /**
     * Set IncludeLinkedVehicles value
     * @param bool $includeLinkedVehicles
     * @return \StructType\GeoFenceSelection_V3
     */
    public function setIncludeLinkedVehicles($includeLinkedVehicles = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeLinkedVehicles) && !is_bool($includeLinkedVehicles)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeLinkedVehicles, true), gettype($includeLinkedVehicles)), __LINE__);
        }
        $this->IncludeLinkedVehicles = $includeLinkedVehicles;
        return $this;
    }
    /**
     * Get IdentifierGeoFence value
     * @return \StructType\IdentifierGeoFence|null
     */
    public function getIdentifierGeoFence()
    {
        return $this->IdentifierGeoFence;
    }
    /**
     * Set IdentifierGeoFence value
     * @param \StructType\IdentifierGeoFence $identifierGeoFence
     * @return \StructType\GeoFenceSelection_V3
     */
    public function setIdentifierGeoFence(\StructType\IdentifierGeoFence $identifierGeoFence = null)
    {
        $this->IdentifierGeoFence = $identifierGeoFence;
        return $this;
    }
    /**
     * Get IdentifierVehicleStrategy value
     * @return \StructType\IdentifierVehicleStrategy|null
     */
    public function getIdentifierVehicleStrategy()
    {
        return $this->IdentifierVehicleStrategy;
    }
    /**
     * Set IdentifierVehicleStrategy value
     * @param \StructType\IdentifierVehicleStrategy $identifierVehicleStrategy
     * @return \StructType\GeoFenceSelection_V3
     */
    public function setIdentifierVehicleStrategy(\StructType\IdentifierVehicleStrategy $identifierVehicleStrategy = null)
    {
        $this->IdentifierVehicleStrategy = $identifierVehicleStrategy;
        return $this;
    }
}
